package stdlib;

import gud.exec.State;
import gud.objects.*;

public class Utils 
{
	public static final void init( State s )
	{
		// At the bottommost layer in the naming hierarchy, below
		// the internal dispatched toRaw and toFormatted, the toString
		// method gets called on the Value class.  Value exports
		// a 'setName' method that can be used to modify that lowest-level
		// name.  We use this to set names of internal objects like 'true'
		// in a way that doesn't require dispatching.
		Builtins.add( s, "setName", Builtins.genInternal(
			new InternalCall() {
				public Value call( State s, Value[] vs ) 
				{
					StringValue sv = (StringValue)( vs[ 1 ] );
					vs[ 0 ].setName( sv.getString() );
					return Builtins.vtao;
				}
			}, null, Builtins.vstring ) );

		// Call some debugging code in the 'State' class that dumps out
		// its symbol table.
		Builtins.add( s, "dump", Builtins.genInternal(
			new InternalCall() {
				public Value call( State s, Value[] vs ) 
				{
					s.dumpGlobals();
					return Builtins.vtao;
				}
			} ) );
	}
}
